/*
 * Copyright (c) 2018, salesforce.com, inc.
 * All rights reserved.
 * SPDX-License-Identifier: MIT
 * For full license text, see the LICENSE file in the repo root or https://opensource.org/licenses/MIT
 */
export const addGlobalEventListener = jest.fn();
export const removeGlobalEventListener = jest.fn();
export const dispatchGlobalEvent = jest.fn();
export const connectMessengerToBus = jest.fn();

const DispatchGlobalEvent = Symbol('dispatchGlobalEvent');
const AddGlobalEventListener = Symbol('addGlobalEventListener');
const RemoveGlobalEventListener = Symbol('removeGlobalEventListener');

export const EventBusMixin = base => {
    return class extends base {
        [DispatchGlobalEvent]() {}
        [AddGlobalEventListener]() {}

        [RemoveGlobalEventListener]() {}
    };
};

EventBusMixin.DispatchGlobalEvent = DispatchGlobalEvent;
EventBusMixin.AddGlobalEventListener = AddGlobalEventListener;
EventBusMixin.RemoveGlobalEventListener = RemoveGlobalEventListener;
